/***************************************************************************
 *   Copyright (C) 2005 by GUILLAUME Nicolas                               *
 *   ng@ngsoft-fr.com                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FORMNEW_H
#define FORMNEW_H

#include "FormNewBase.h"
#include "smsmessage.h"
#include <qmessagebox.h>
#include <qstatusbar.h>
#include <qaction.h>
#include "qtextedit.h"
#include "qlineedit.h"
#include "formcontacts.h"

extern QApplication *current_app;


class FormNew : public FormNewBase
{
  Q_OBJECT

public:
	FormNew(QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
	FormNew(QWidget* parent, const QString& address, const QString& message);
	~FormNew();
	
	void prepareSendMessage(bool isDraft);
  /*$PUBLIC_FUNCTIONS$*/
signals:
	void messageReady(SMSManager::SMSMessage);
	void messageInDraft(SMSManager::SMSMessage);
  
public slots:
  /*$PUBLIC_SLOTS$*/
 	void actionSend();
	void txtMessChanged();
	void actionDraft();
	void btnBrowseClick();

protected:
  /*$PROTECTED_FUNCTIONS$*/

protected slots:
  /*$PROTECTED_SLOTS$*/

};

#endif

